<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class Fm00004000TarefasFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getTarefasGrid($parametros, $listaOperadores)
    {
        $sql = "SELECT  FCM_CHECKLISTAGEND.NRCHECKLISTAGEND, FCM_CHECKLISTAGEND.NMCHECKLISTAGEND, TO_CHAR(FCM_CHECKLISTAGEND.DTHORAAGEND, 'DD/MM/YYYY HH24:MI') AS DTHORAAGEND,
                          TO_CHAR(FCM_CHECKLISTAGEND.DTHRFINALAGEND, 'DD/MM/YYYY HH24:MI') AS DTHRFINALAGEND,
                          FCM_LOCALCLI.NRLOCALCLIENTE, FCM_LOCALCLI.NMLOCALCLIENTE,
                          FCM_TIPOLOCALCLI.NRTIPOLOCALCLI, FCM_TIPOLOCALCLI.NMTIPOLOCALCLI,
                          FCM_CHECKLIST.NRCHECKLIST, FCM_CHECKLIST.NMCHECKLIST,
                          FCM_CHECKLISTAGEND.IDSITUACAOAGEND, OPERADOR.NMOPERADOR, FCM_CHECKLISTAGEND.CDOPERADOR, FCM_LOCALCLI.CDCLIENTE, CLIENTE.NMRAZSOCCLIE
                    FROM FCM_CHECKLISTAGEND
                    JOIN FCM_LOCALCLI
                      ON FCM_CHECKLISTAGEND.NRLOCALCLIENTE = FCM_LOCALCLI.NRLOCALCLIENTE
                    JOIN CLIENTE
                      ON  CLIENTE.CDCLIENTE = FCM_LOCALCLI.CDCLIENTE
                    JOIN FCM_TIPOLOCALCLI
                      ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                    JOIN FCM_CHECKLIST
                      ON FCM_CHECKLISTAGEND.NRCHECKLIST = FCM_CHECKLIST.NRCHECKLIST
                    LEFT JOIN OPERADOR
                      ON FCM_CHECKLISTAGEND.CDOPERADOR = OPERADOR.CDOPERADOR
                    WHERE ((FCM_CHECKLISTAGEND.CDOPERADOR IN ($listaOperadores))
                      OR (FCM_CHECKLISTAGEND.CDOPERINCLUSAO = :CDOPERADOR))
                    ORDER BY FCM_CHECKLISTAGEND.DTHORAAGEND DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function getClientes()
    {
        $sql = "SELECT CDCLIENTE, NMRAZSOCCLIE 
                  FROM CLIENTE
                  WHERE IDCLIEATIV = 'S'
                      AND IDATIVO = 'S' 
                      AND CDCLIENTE IN (SELECT CDCLIENTE 
                                          FROM FCM_LOCALCLI
                                      WHERE IDATIVO = 'S')";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTipoLocal()
    {

        $sql = "SELECT NRTIPOLOCALCLI, NMTIPOLOCALCLI 
                FROM FCM_TIPOLOCALCLI
              WHERE IDATIVO = 'S'";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getLocal($param)
    {
      
        $sql = "SELECT NMLOCALCLIENTE, NRLOCALCLIENTE
                FROM FCM_LOCALCLI
                WHERE NRTIPOLOCALCLI IN (" . $param . ")";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getChecklistTarefa($param)
    {
     
        $sql = "SELECT NRCHECKLIST, 
                       NMCHECKLIST
                  FROM FCM_CHECKLIST
                  WHERE NRTIPOLOCALCLI IN (" . $param . ")";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getItensChecklist($parametros)
    {
        $sql = "SELECT FCM_ATIVIDADECHK.NRATIVIDADECHK, FCM_ATIVIDADE.NMATIVIDADE 
        FROM FCM_ATIVIDADE
        JOIN FCM_ATIVIDADECHK
        ON FCM_ATIVIDADE.NRATIVIDADE = FCM_ATIVIDADECHK.NRATIVIDADE
        JOIN FCM_CHECKLIST
        ON FCM_ATIVIDADECHK.NRCHECKLIST = FCM_CHECKLIST.NRCHECKLIST
        WHERE FCM_CHECKLIST.NRCHECKLIST = " . $parametros['NRCHECKLIST'];

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getEscopo()
    {
        $sql = "SELECT DISTINCT FCM_ESCOPOSTAREFA.NRESCOPOSTAREFA, FCM_ESCOPOSTAREFA.NMESCOPOSTAREFA, FCM_ATIVIDADECHK.NRATIVIDADECHK
        FROM FCM_ESCOPOSTAREFA
        LEFT JOIN FCM_TAGSTAREFA
        ON FCM_ESCOPOSTAREFA.NRESCOPOSTAREFA = FCM_TAGSTAREFA.NRESCOPOSTAREFA
        LEFT JOIN FCM_TAGSCHKTAREFA
        ON FCM_TAGSTAREFA.NRTAGSTAREFA = FCM_TAGSCHKTAREFA.NRTAGSTAREFA
        LEFT JOIN FCM_TAREFACHK
        ON FCM_TAREFACHK.NRTAREFACHK = FCM_TAGSCHKTAREFA.NRTAREFACHK
        LEFT JOIN FCM_ATIVIDADECHK
        ON FCM_ATIVIDADECHK.NRATIVIDADECHK = FCM_TAREFACHK.NRATIVIDADECHK";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTarefasSelect($param)
    {
        $sql = "SELECT A.NRTAREFACHK, C.NMTAREFA
                FROM FCM_TAREFACHK A
                JOIN FCM_ATIVIDADECHK B
                ON A.NRATIVIDADECHK = B.NRATIVIDADECHK
                JOIN FCM_TAREFA C
                ON A.NRTAREFA = C.NRTAREFA
                WHERE B.NRATIVIDADECHK IN (" . $param . ")";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getCriterios($param)
    {
        $sql = "SELECT A.NRCRITERIOTAREFACHK, A.NRCRITERIOTAREFA,B.DSCRITERIOTAREFA, A.NRTAREFACHK, E.NRCHECKLIST, D.NRATIVIDADECHK
                  FROM FCM_CRITERIOTAREFACHK A
                  JOIN FCM_CRITERIOTAREFA B
                    ON A.NRCRITERIOTAREFA = B.NRCRITERIOTAREFA
                  JOIN FCM_TAREFACHK C
                    ON A.NRTAREFACHK = C.NRTAREFACHK
                  JOIN FCM_ATIVIDADECHK D
                    ON C.NRATIVIDADECHK = D.NRATIVIDADECHK
                  JOIN FCM_CHECKLIST E
                    ON E.NRCHECKLIST = D.NRCHECKLIST
                 WHERE A.NRTAREFACHK IN (" . $param['NRTAREFACHK'] . ")
                   AND E.NRCHECKLIST  = " . $param['NRCHECKLIST'] . "
                   AND D.NRATIVIDADECHK IN (" . $param['NRATIVIDADECHK'] . ")";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getFuncionario()
    {
        $sql = "SELECT FUNC.CDOPERADOR, FUNC.NMOPERADOR
              FROM OPERADOR FUNC
              LEFT JOIN FCM_FUNCIONARIOSHIERARQ FHIER
                ON FHIER.CDOPERADOR = FUNC.CDOPERADOR                    
              WHERE FHIER.NRHIERARQUIAFUNC IN (SELECT NRHIERARQUIAFUNC 
                                                 FROM FCM_HIERARQUIAFUNC 
                                                WHERE IDATIVO = 'S')
                AND FUNC.CDOPERADOR NOT IN (SELECT DISTINCT NVL(CDOPERADORPAI,0) AS OPERADOR
                          FROM FCM_FUNCIONARIOSHIERARQ 
                         WHERE  NRHIERARQUIAFUNC IN (SELECT NRHIERARQUIAFUNC 
                                                 FROM FCM_HIERARQUIAFUNC 
                                                WHERE IDATIVO = 'S'))";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getSupervisorTarefa()
    {
        $sql = "SELECT FUNC.CDOPERADOR, FUNC.NMOPERADOR
            FROM OPERADOR FUNC
            LEFT JOIN FCM_FUNCIONARIOSHIERARQ FHIER
              ON FHIER.CDOPERADOR = FUNC.CDOPERADOR                    
            WHERE FHIER.NRHIERARQUIAFUNC IN (SELECT NRHIERARQUIAFUNC 
                                               FROM FCM_HIERARQUIAFUNC 
                                              WHERE IDATIVO = 'S')
              AND FUNC.CDOPERADOR IN (SELECT DISTINCT NVL(CDOPERADORPAI,0) AS CDOPERADOR
                        FROM FCM_FUNCIONARIOSHIERARQ 
                       WHERE  NRHIERARQUIAFUNC IN (SELECT NRHIERARQUIAFUNC 
                                               FROM FCM_HIERARQUIAFUNC 
                                              WHERE IDATIVO = 'S'))";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function insertChecklist($params)
    {

        $sql = "INSERT INTO FCM_CHECKLISTAGEND (
                                NRCHECKLISTAGEND, NMCHECKLISTAGEND, NRLOCALCLIENTE, 
                                NRCHECKLIST, CDOPERADOR, IDSITUACAOAGEND, 
                                DTHORAAGEND,  IDATIVO, DTINCLUSAO, 
                                DTHRFINALAGEND, CDOPERINCLUSAO, IDOBRIGAOBSERVACAO
                )
                     VALUES (
                            :NRCHECKLISTAGEND, :NMCHECKLISTAGEND, :NRLOCALCLIENTE, 
                            :NRCHECKLIST, :CDOPERADOR, :IDSITUACAOAGEND,
                            :DTHORAAGEND, 'S', SYSDATE, 
                            :DTHRFINALAGEND, :CDOPERINCLUSAO, :IDOBRIGAOBSERVACAO
                    )";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function insertTarefa($params)
    {
        $sql = "INSERT INTO FCM_TAREFAAGEND (
                                NRTAREFAAGEND, NRCHECKLISTAGEND, NRTAREFACHK, 
                                CDOPERADOR, DTHORATAREFAAGEND, DSOBSTAREFAAGEND, 
                                IDREALIZADO,  IDATIVO, DTINCLUSAO, 
                                CDOPERINCLUSAO
            )
            VALUES (
                    :NRTAREFAAGEND, :NRCHECKLISTAGEND, :NRTAREFACHK, 
                    :CDOPERADOR, :DTHORAAGEND, :DSOBSTAREFAAGEND, 
                    'N',  'S', SYSDATE, 
                    :CDOPERINCLUSAO)";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function insertCriterio($params)
    {

        $sql = "INSERT INTO FCM_CRITERIOTARAGEND (
                                NRCRITERIOTARAGEND, NMCRITERIOTARAGEND, NRTAREFAAGEND, 
                                NRCRITERIOTAREFACHK, IDATIVO, DTINCLUSAO, 
                                CDOPERINCLUSAO
            )
                    VALUES (
                        :NRCRITERIOTARAGEND,:NMCRITERIOTARAGEND, :NRTAREFAAGEND, 
                        :NRCRITERIOTAREFACHK, 'S', SYSDATE, 
                        :OPERADOR
                    )";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function insertChk($params)
    {
        $sql = "INSERT INTO FCM_GERENCIAMENTOCHK (
                                NRGERENCIAMENTOCHK, NMGERENCIAMENTOCHK, NRLOCALCLIENTE, 
                                NRCHECKLIST, CDOPERADOR, IDSITUACAOGERCHK, 
                                DTHORAAGEND, IDATIVO, DTINCLUSAO, 
                                CDOPERINCLUSAO, NRCHECKLISTAGEND,DTHRFINALAGEND, IDOBRIGAOBSERVACAO
                )
                VALUES (
                    :NRGERENCIAMENTOCHK, :NMGERENCIAMENTOCHK, :NRLOCALCLIENTE, 
                    :NRCHECKLIST, :CDOPERADOR, '1',  
                    :DTHORAAGEND, 'S', SYSDATE, 
                    :OPERADOR, :NRCHECKLISTAGEND,TO_DATE(:DTHRFINALAGEND), :IDOBRIGAOBSERVACAO
                )";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function insertChkTarefa($params)
    {
        $sql = "INSERT INTO FCM_TAREFAGERCHK (
            NRTAREFAGERCHK, NRGERENCIAMENTOCHK, NRTAREFACHK, 
            CDOPERADOR, DTHORATAREFAGERCHK, DSOBSTAREFAGERCHK, 
            IDATIVO, DTINCLUSAO,  CDOPERINCLUSAO
            )
 VALUES (
    :NRTAREFAGERCHK, :NRGERENCIAMENTOCHK, :NRTAREFACHK, 
    :CDOPERADOR, :DTHORATAREFAGERCHK, :DSOBSTAREFAGERCHK, 
    'S', SYSDATE, :OPERADOR
    )";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    public function insertChkCriterio($params)
    {
        $sql = "INSERT INTO FCM_CRITERIOTARGERCHK (
                                NRCRITERIOTARGERCHK, NMCRITERIOTARGERCHK, NRTAREFAGERCHK, 
                                NRCRITERIOTAREFACHK, IDATIVO, DTINCLUSAO, 
                                CDOPERINCLUSAO
                )
                     VALUES (
                        :NRCRITERIOTARGERCHK, :NMCRITERIOTARGERCHK,
                        :NRTAREFAGERCHK, :NRCRITERIOTAREFACHK,  'S', 
                        SYSDATE, :OPERADOR
                    )";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function deletarTarefas($param)
    {
        $sql = "DELETE FROM FCM_CRITERIOTARGERCHK
                     WHERE NRTAREFAGERCHK IN (SELECT NRTAREFAGERCHK
                                                FROM FCM_TAREFAGERCHK
                                               WHERE NRGERENCIAMENTOCHK IN (SELECT NRGERENCIAMENTOCHK
                                                                              FROM FCM_GERENCIAMENTOCHK
                                                                             WHERE NRCHECKLISTAGEND IN (" . $param . ")))";

        $std = $this->connection->prepare($sql);
        $std->execute();

        $sql = "DELETE FROM FCM_TAREFAGERCHK 
                    WHERE NRGERENCIAMENTOCHK IN (SELECT NRGERENCIAMENTOCHK
                                                   FROM FCM_GERENCIAMENTOCHK
                                                  WHERE NRCHECKLISTAGEND IN (" . $param . "))";

        $std = $this->connection->prepare($sql);
        $std->execute();


        $sql = "DELETE FROM FCM_CRITERIOTARAGEND
               WHERE NRTAREFAAGEND IN (SELECT NRTAREFAAGEND
                                         FROM FCM_TAREFAAGEND 
                                        WHERE NRCHECKLISTAGEND IN (" . $param . "))";

        $std = $this->connection->prepare($sql);
        $std->execute();

        $sql = "DELETE FROM FCM_TAREFAAGEND WHERE NRCHECKLISTAGEND IN (" . $param . ")";

        $std = $this->connection->prepare($sql);
        $std->execute();

        $sql = "DELETE FROM FCM_GERENCIAMENTOCHK
               WHERE NRCHECKLISTAGEND IN (" . $param . ")";

        $std = $this->connection->prepare($sql);
        $std->execute();


        $sql = "DELETE FROM FCM_CHECKLISTAGEND WHERE NRCHECKLISTAGEND IN (" . $param . ")";

        $std = $this->connection->prepare($sql);
        $std->execute();
    }
}
