/* eslint-disable */
import {
  Http, IDictionary, Metadata, SimpleDatasource,
} from '@zeedhi/core';
import { 
  CheckboxMultiple, LoadingService, Modal, ModalService, Text, Textarea,
} from '@zeedhi/common';
import { Utilities } from '@/util/Utilities';
  
  export class RelatorioVistoriaController {
      private modal!: Modal;

      private currentRow: any;

      public async abrirModal() {
        LoadingService.show();
        this.modal = await ModalService.createFromJson('/relatorios/modal/visualizar_infos_relatorio_vistoria', true);
        this.modal.show();
        LoadingService.hide();
      }
    
      public closeModal() {
        this.modal.hide();
        this.modal?.destroy();
      }

      public rowClick({ row }: any ) {
        this.currentRow = row;
        console.log(this.currentRow);
        this.abrirModal();
      }

      public montarInformacoesComplementares() {
        LoadingService.show();
        const nr = this.currentRow.NRGERENCIAMENTOCHK;
        const checkbox = Metadata.getInstance<CheckboxMultiple>('checkbox-naoconformidades');
        const semItens = Metadata.getInstance<Text>('nao-ha-conformidades');
  
        Http.post('/getCriteriosVistoria', {
          NRGERENCIAMENTOCHK: nr,
        }).then((response: IDictionary) => {
          const dados = response.data.data;

          checkbox.value = dados.filter((elemento: any) => elemento.IDMARCADO === 'S').map((elemento: any) => elemento.NRCRITERIOTARGERCHK);
          (checkbox.datasource as SimpleDatasource)!.data = dados;
  
          if (dados.length > 0) {
            semItens.isVisible = false;
          } else {
            semItens.isVisible = true;
          }

          // não permite repetição de valores (new set)
          const observacoes = [
            ...new Set(
              dados.map((element: any) => element.DSOBSTAREFAGERCHK)
            ),
          ];

          Metadata.getInstance<Textarea>('observacoes-vistoria').value = observacoes.join('\n');
          
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
          LoadingService.hide();
        });
      }
    
      public carregarFotos({ component }: any) {
        const nr = this.currentRow.NRGERENCIAMENTOCHK;
  
        LoadingService.show();
        Http.post('/getFotosVistoria', {
          NRGERENCIAMENTOCHK: nr
        }).then((response: any) => {
          if(response.data.data.length === 0) {
            component.isVisible = false;
            Metadata.getInstance<Text>('sem-resultado-imagens-vistorias').isVisible = true;
          } else {
            response.data.data.forEach((dados: IDictionary) => {
              component.iterable.datasource.data.push({
                NRFOTOTAREFAGERCHK: dados.NRFOTOTAREFAGERCHK,
                DSFOTOTAREFAGERCHK: dados.DSFOTOTAREFAGERCHK,
              });
            });
          }
        }).catch((error : any) =>{
          Utilities.showErrorMessage(error);
        }).finally(() => {
          LoadingService.hide();
        });
      }
  }
  